/*
	$Id: Compounds.java 264 2006-08-18 21:19:31Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.util.List;
import java.io.PrintWriter;

/**
   ¤Τޤ϶Τޤ󷿤ΥåȤǤ

   ȥåץ٥륳ѥɤΥåȤݻޤ
*/
public class Compounds {

    /** ȥåץ٥륳ѥɤΥꥹ */
    private LinkedList<ToplevelCompound> v;

    /** 롼ץޥ͡ */
    private GroupManager gm;

    /**
       ȥåץ٥륳ѥɤΥåȤޤ

       @param gm 롼ץޥ͡
       @param nodes structǤޤunionǤޤenumǤΥΡɥ
       
    */
    public Compounds(final GroupManager gm, final NodeList nodes) {
	this.gm = gm;
	v = new LinkedList<ToplevelCompound>();

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    String name = elem.getNodeName();
	    ToplevelCompound m;
	    if (name.equals("struct")) {
		m = gm.createStruct(elem);
	    } else if (name.equals("union")) {
		m = gm.createUnion(elem);
	    } else if (name.equals("enum")) {
		m = gm.createEnum(elem);
	    } else {
		throw new NodeException(elem, "unknown element name");
	    }
	    v.add(m);
	}
    }

    /**
       ȥåץ٥륳ѥɤΥɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	for (ToplevelCompound m : v) {
	    wr.println("");
	    m.printCode(wr);
	}
    }

    /**
       ѥɤHTMLǽϤޤ

       @param wr 饤
       @param label "Struct" ޤ "Union" ޤ "Enum"
       @param s ѥɤΥꥹ
    */
    private void printCompoundSummary(final PrintWriter wr, final String label,
				      final List<Compound> s) {
	if (s.size() == 0) {
	    return;
	}

	wr.println(""
+ "    <h2>" + label + " Summary</h2>");
	for (Compound c : s) {
	    c.printCompoundSummary(wr);
	}
    }

    /**
       Ʊ롼פΤ٤ƤΥѥɤHTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	printCompoundSummary(wr, "Struct", gm.getAllStructs());
	printCompoundSummary(wr, "Union", gm.getAllUnions());
	printCompoundSummary(wr, "Enum", gm.getAllEnums());
    }

    /**
       ѥɤξܺ٤HTMLǽϤޤ

       @param wr 饤
       @param label "Struct" ޤ "Union" ޤ "Enum"
       @param s ѥɤΥꥹ
    */
    private void printCompoundDetail(final PrintWriter wr, final String label,
				     final List<Compound> s) {
	if (s.size() == 0) {
	    return;
	}
	wr.println(""
+ "    <h2>" + label + " Detail</h2>");
	for (Compound c : s) {
	    c.printCompoundDetail(wr);
	}
    }

    /**
       Ʊ롼פΤ٤ƤΥѥɤξܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	printCompoundDetail(wr, "Struct", gm.getAllStructs());
	printCompoundDetail(wr, "Union", gm.getAllUnions());
	printCompoundDetail(wr, "Enum", gm.getAllEnums());
    }

    /**
       ѥɤξܺ٤TeXǽϤޤ

       @param wr 饤
       @param label "Struct" ޤ "Union" ޤ "Enum"
       @param s ѥɤΥꥹ
    */
    private void printTexCompoundDetail(final PrintWriter wr,
					final String label,
					final List<Compound> s) {
	if (s.size() == 0) {
	    return;
	}
	wr.println("\\S" + label.toLowerCase());
	for (Compound c : s) {
	    c.printTexCompoundDetail(wr);
	}
    }

    /**
       Ʊ롼פΤ٤ƤΥѥɤξܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	printTexCompoundDetail(wr, "Struct", gm.getAllStructs());
	printTexCompoundDetail(wr, "Union", gm.getAllUnions());
	printTexCompoundDetail(wr, "Enum", gm.getAllEnums());
    }
}
