/*
	$Id: GroupManager.java 272 2006-08-19 22:38:42Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import org.w3c.dom.Element;

/**
   롼ץޥ͡Ǥ

   롼ץޥ͡ϤѥåΥ롼סʥ饹ޤϥ󥿥ե
   ˤޤ
*/
public class GroupManager {

    /** Υ롼פ֤̾ΰ */
    private Location location;

    /** Υ롼פ̾Ÿλ */
    private String nameSpace;

    /** Υ롼פ˽°빽¤ */
    private LinkedList<Compound> structs;

    /** Υ롼פ˽°붦 */
    private LinkedList<Compound> unions;

    /** Υ롼פ˽° */
    private LinkedList<Compound> enums;

    /** Υ롼פ˽°뼱̻ҤΥޥå */
    private HashSet<String> names;

    /** ̻ҥޥ͡ */
    private IDManager idManager;

    /**
       롼ץޥ͡ޤ

       @param packageName ѥå̾
       @param name 饹̾ޤϥ󥿥ե̾
       @param nameSpace ̾Ÿλ
    */
    public GroupManager(final String packageName, final String name,
			final String nameSpace) {
	this.nameSpace = nameSpace;
	location = new Location(packageName, name);
	structs = new LinkedList<Compound>();
	unions = new LinkedList<Compound>();
	enums = new LinkedList<Compound>();
	names = new HashSet<String>();
	idManager = IDManager.getInstance();
    }

    /**
       Υ롼פ˽°륨ݡȤޤ

       @param elem export
       @return ݡ
    */
    public Export createExport(final Element elem) {
	Export m = new Export(this, elem);
	String type = m.getType();
	if (type.equals("struct")) {
	    structs.add(m);
	} else if (type.equals("union")) {
	    unions.add(m);
	} else if (type.equals("enum")) {
	    enums.add(m);
	}
	idManager.addKeyword(location, m.getDescType());
	return m;
    }

    /**
       Υ롼פ˽°뷿ޤ

       @param elem typedef
       @return 
    */
    public Typedef createTypedef(final Element elem) {
	Typedef m = new Typedef(this, elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°ޥޤ

       @param elem define
       @return ޥ
    */
    public Macro createMacro(final Element elem) {
	Macro m = new Macro(this, elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°󷿤ޤ

       @param elem constant
       @return 󷿤
    */
    public Constant createConstant(final Element elem) {
	Constant m = new Constant(this, elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°ؿޤ

       @param elem method
       @return ؿ
    */
    public Method createRegularMethod(final Element elem) {
	RegularMethod m = new RegularMethod(this, elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°륢֥ȥ饯ȥ᥽åɤޤ

       @param elem abstractmethod
       @return ؿ
    */
    public Method createAbstractMethod(final Element elem) {
	Method m = new AbstractMethod(this, elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°륰Хѿޤ

       @param elem globalvariable
       @return Хѿ
    */
    public GlobalVariable createGlobalVariable(final Element elem) {
	GlobalVariable m = new GlobalVariable(this, elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°빽¤Τޤ϶ΤΥФޤ

       @param parentName Ф°빽¤Τޤ϶Τ̾
       @param elem memberǡstructmemberǡunionmemberǡ
       enummemberǡޤmethod
       @return ¤Τޤ϶ΤΥ
    */
    public Member createMember(final String parentName, final Element elem) {
	if (elem.getNodeName().equals("structmember")) {
	    String tag = expandImpliedNS(elem, "tag");
	    StructUnionMember m
		= new StructUnionMember(this, parentName, "struct", tag, elem);
	    structs.add(m);
	    idManager.addKeyword(location, m.getDescType());
	    return m;
	} else if (elem.getNodeName().equals("unionmember")) {
	    String tag = expandImpliedNS(elem, "tag");
	    StructUnionMember m
		= new StructUnionMember(this, parentName, "union", tag, elem);
	    unions.add(m);
	    idManager.addKeyword(location, m.getDescType());
	    return m;
	} else if (elem.getNodeName().equals("enummember")) {
	    String tag = expandImpliedNS(elem, "tag");
	    EnumMember m = new EnumMember(this, parentName, tag, elem);
	    enums.add(m);
	    idManager.addKeyword(location, m.getDescType());
	    return m;
	} else if (elem.getNodeName().equals("method")) {
	    Member m = new MethodMember(this, parentName, elem);
	    idManager.addKeyword(location, parentName + "." + m.getName());
	    return m;
	} else {
	    String type = expandAT(elem, "type");
	    Member m = new Member(parentName, type, elem);
	    idManager.addKeyword(location, parentName + "." + m.getName());
	    return m;
	}
    }

    /**
       ̾Ÿ°ͤޤ

       @param elem 
       @param attrName °̾
       @return °ꤵƤʤжʸ󡢤Ǥʤ̾
       Ÿ°
    */
    private String expandImpliedNS(final Element elem, final String attrName) {
	if (elem.getAttributeNode(attrName) == null) {
	    return "";
	}
	return expandNS(elem, attrName);
    }

    /**
       Υ롼פ˽°빽¤Τޤ

       @param elem struct
       @return ¤
    */
    public StructUnion createStruct(final Element elem) {
	String tag = expandImpliedNS(elem, "tag");
	String as = expandImpliedNS(elem, "alias");

	if (tag.equals("") && as.equals("")) {
	    throw new NodeException(elem, "nameless struct.");
	}
	StructUnion m = new StructUnion(this, "struct", elem, tag, as);
	structs.add(m);
	idManager.addKeyword(location, m.getDescType());
	idManager.addKeyword(location, as);
	return m;
    }

    /**
       Υ롼פ˽°붦Τޤ

       @param elem union
       @return 
    */
    public StructUnion createUnion(final Element elem) {
	String tag = expandImpliedNS(elem, "tag");
	String as = expandImpliedNS(elem, "alias");

	if (tag.equals("") && as.equals("")) {
	    throw new NodeException(elem, "nameless union.");
	}
	StructUnion m = new StructUnion(this, "union", elem, tag, as);
	unions.add(m);
	idManager.addKeyword(location, m.getDescType());
	idManager.addKeyword(location, as);
	return m;
    }

    /**
       Υ롼פ˽°󷿤ޤ

       @param elem enum
       @return 
    */
    public Enum createEnum(final Element elem) {
	String tag = expandImpliedNS(elem, "tag");
	String as = expandImpliedNS(elem, "alias");

	if (tag.equals("") && as.equals("")) {
	    throw new NodeException(elem, "nameless enum.");
	}
	Enum m = new Enum(this, elem, tag, as);
	enums.add(m);
	idManager.addKeyword(location, m.getDescType());
	idManager.addKeyword(location, as);
	return m;
    }

    /**
       Υ롼פ˽°빽¤ΤΥꥹȤޤ

       @return ¤ΤΥꥹ
    */
    public List<Compound> getAllStructs() {
	return structs;
    }

    /**
       Υ롼פ˽°붦ΤΥꥹȤޤ

       @return ΤΥꥹ
    */
    public List<Compound> getAllUnions() {
	return unions;
    }

    /**
       Υ롼פ˽°󷿤ΥꥹȤޤ

       @return 󷿤Υꥹ
    */
    public List<Compound> getAllEnums() {
	return enums;
    }

    /**
       ʸ˴ޤޤ@פ򤳤֤̾ɽץեåŸ
       ޤCΥȤ˴ޤޤ@פŸޤ

       CΥȤĤƤʤnull֤ޤ

       @param s ʸ
       @return Ÿʸ
    */
    private String expandATString(final String s) {
	int j;
	String t = s;
	String z = "";

	z = "";
	while (t.length() > 0 && (j = t.indexOf("/*")) != -1) {
	    String u = t.substring(0, j);
	    String v = t.substring(j + 2);
	    int k = v.indexOf("*/");

	    if (k == -1) {
		return null;
	    }
	    z += u.replaceAll("@", location.getPrefix())
		+ "/*" + v.substring(0, k) + "*/";
	    t = v.substring(k + 2);
	}
	return z + t.replaceAll("@", location.getPrefix());
    }

    /**
       Ǥ°ͤ@Ÿ̤ޤ

       @param elem 
       @param attrName °̾
       @return @Ÿ°
    */
    public String expandAT(final Element elem, final String attrName) {
	String s = elem.getAttribute(attrName);
	if (s.equals("")) {
	    String m = "empty value: " + attrName;
	    throw new NodeException(elem.getAttributeNode(attrName), m);
	}
	s = expandATString(s);
	if (s == null) {
	    String m = "unterminated comment: " + attrName;
	    throw new NodeException(elem.getAttributeNode(attrName), m);
	}
	return s;
    }

    /**
       Ǥ°ͤ򤳤Υ롼פ֤̾Ÿޤ

       ̾Ÿλ꤬: ̻Ҥ@פξϤ̾
       ɽץեåŸޤʳξ硢ץեå
        + "_" + ̻Ҥ֤ޤisImportedtrueξϡŸ
       ̻Ҥ򥤥ݡȥޥȤϿޤ

       ̾Ÿλ꤬ʤ: @Ÿη̤֤ޤ

       @param elem 
       @param attrName °̾
       @param isImported ݡȥޥϿtrue
       @return ̾Ÿޤ@Ÿ°
    */
    public String expandNS(final Element elem, final String attrName,
			   final boolean isImported) {
	String t;
	if (nameSpace == null) {
	    t = expandAT(elem, attrName);
	} else {
	    String s = elem.getAttribute(attrName);
	    if (s.equals("")) {
		String m = "empty value: " + attrName;
		throw new NodeException(elem.getAttributeNode(attrName), m);
	    }
	    if (isImported) {
		names.add(s);
	    }
	    t = prependPrefix(location.getPrefix(), s);
	}
	if (!idManager.isCID(t)) {
	    String m = "invalid identifier: " + t;
	    throw new NodeException(elem.getAttributeNode(attrName), m);
	}
	return t;
    }

    /**
       Ǥ°ͤ򤳤Υ롼פ֤̾Ÿޤ

       expandNS(elem, attrName, true)Ʊ̣Ǥ

       @param elem 
       @param attrName °̾
       @return ̾Ÿޤ@Ÿ°
    */
    public String expandNS(final Element elem, final String attrName) {
	return expandNS(elem, attrName, true);
    }

    /**
       ʸ˥ץեå֤ޤ

       @param prefix ץեå
       @param s ʸ
       @return s "@" ξ prefixʳξ prefix + "_"
       + s
    */
    private String prependPrefix(final String prefix, final String s) {
	if (s.equals("@")) {
	    return prefix;
	}
	return prefix + "_" + s;
    }

    /**
       ݡȥޥϤޤ

       @param wr 饤
    */
    public void printImportMacro(final PrintWriter wr) {
	String longPrefix = location.getPrefix();
	String shortPrefix = location.getShortPrefix();
	String[] sortedNames = names.toArray(new String[0]);
	Arrays.sort(sortedNames);
	for (String s : sortedNames) {
	    String longName = prependPrefix(longPrefix, s);
	    String shortName = prependPrefix(shortPrefix, s);
	    wr.println("#define " + shortName + " " + longName);
	}
    }
}
